"""
    wallet-api

    API  # noqa: E501

    The version of the OpenAPI document: 2.1.524
    Contact: development@wallet.inc
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from wallet.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from wallet.exceptions import ApiAttributeError


def lazy_import():
    from wallet.model.ss_nano_id import SSNanoID
    globals()['SSNanoID'] = SSNanoID


class InboundSMS(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('id',): {
            'max_length': 12,
            'min_length': 10,
        },
        ('num_segments',): {
            'inclusive_minimum': 0,
        },
        ('num_media',): {
            'inclusive_minimum': 0,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'automated_reply': (str,),  # noqa: E501
            'automated_reply_additional_info': (str,),  # noqa: E501
            'sms_sid': (str,),  # noqa: E501
            'sms_message_sid': (str,),  # noqa: E501
            'sms_status': (str,),  # noqa: E501
            'account_sid': (str,),  # noqa: E501
            'message_sid': (str,),  # noqa: E501
            'body': (str,),  # noqa: E501
            'num_segments': (int,),  # noqa: E501
            'to': (str,),  # noqa: E501
            'to_city': (str,),  # noqa: E501
            'to_state': (str,),  # noqa: E501
            'to_zip': (str,),  # noqa: E501
            'to_country': (str,),  # noqa: E501
            '_from': (str,),  # noqa: E501
            'from_city': (str,),  # noqa: E501
            'from_state': (str,),  # noqa: E501
            'from_zip': (str,),  # noqa: E501
            'from_country': (str,),  # noqa: E501
            'num_media': (int,),  # noqa: E501
            'api_version': (str,),  # noqa: E501
            'merchant_id': (SSNanoID,),  # noqa: E501
            'created_at': (datetime,),  # noqa: E501
            'updated_at': (datetime,),  # noqa: E501
            'is_active': (bool,),  # noqa: E501
            'body_lowercase': (str,),  # noqa: E501
            'from_localized': (str,),  # noqa: E501
            'messaging_service_sid': (str,),  # noqa: E501
            'media_urls': ([str],),  # noqa: E501
            'watson_intent': (str,),  # noqa: E501
            'watson_intents': (str,),  # noqa: E501
            'watson_context': (str,),  # noqa: E501
            'watson_contexts': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'automated_reply': 'automatedReply',  # noqa: E501
        'automated_reply_additional_info': 'automatedReplyAdditionalInfo',  # noqa: E501
        'sms_sid': 'smsSid',  # noqa: E501
        'sms_message_sid': 'smsMessageSid',  # noqa: E501
        'sms_status': 'smsStatus',  # noqa: E501
        'account_sid': 'accountSid',  # noqa: E501
        'message_sid': 'messageSid',  # noqa: E501
        'body': 'body',  # noqa: E501
        'num_segments': 'numSegments',  # noqa: E501
        'to': 'to',  # noqa: E501
        'to_city': 'toCity',  # noqa: E501
        'to_state': 'toState',  # noqa: E501
        'to_zip': 'toZip',  # noqa: E501
        'to_country': 'toCountry',  # noqa: E501
        '_from': 'from',  # noqa: E501
        'from_city': 'fromCity',  # noqa: E501
        'from_state': 'fromState',  # noqa: E501
        'from_zip': 'fromZip',  # noqa: E501
        'from_country': 'fromCountry',  # noqa: E501
        'num_media': 'numMedia',  # noqa: E501
        'api_version': 'apiVersion',  # noqa: E501
        'merchant_id': 'merchantID',  # noqa: E501
        'created_at': 'createdAt',  # noqa: E501
        'updated_at': 'updatedAt',  # noqa: E501
        'is_active': 'isActive',  # noqa: E501
        'body_lowercase': 'bodyLowercase',  # noqa: E501
        'from_localized': 'fromLocalized',  # noqa: E501
        'messaging_service_sid': 'messagingServiceSid',  # noqa: E501
        'media_urls': 'mediaURLs',  # noqa: E501
        'watson_intent': 'watsonIntent',  # noqa: E501
        'watson_intents': 'watsonIntents',  # noqa: E501
        'watson_context': 'watsonContext',  # noqa: E501
        'watson_contexts': 'watsonContexts',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, automated_reply, automated_reply_additional_info, sms_sid, sms_message_sid, sms_status, account_sid, message_sid, body, num_segments, to, to_city, to_state, to_zip, to_country, _from, from_city, from_state, from_zip, from_country, num_media, api_version, merchant_id, created_at, updated_at, is_active, body_lowercase, from_localized, *args, **kwargs):  # noqa: E501
        """InboundSMS - a model defined in OpenAPI

        Args:
            id (bool, date, datetime, dict, float, int, list, str, none_type):
            automated_reply (str):
            automated_reply_additional_info (str):
            sms_sid (str):
            sms_message_sid (str):
            sms_status (str):
            account_sid (str):
            message_sid (str):
            body (str):
            num_segments (int):
            to (str):
            to_city (str):
            to_state (str):
            to_zip (str):
            to_country (str):
            _from (str):
            from_city (str):
            from_state (str):
            from_zip (str):
            from_country (str):
            num_media (int):
            api_version (str):
            merchant_id (SSNanoID):
            created_at (datetime):
            updated_at (datetime):
            is_active (bool):
            body_lowercase (str):
            from_localized (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            messaging_service_sid (str): [optional]  # noqa: E501
            media_urls ([str]): [optional]  # noqa: E501
            watson_intent (str): [optional]  # noqa: E501
            watson_intents (str): [optional]  # noqa: E501
            watson_context (str): [optional]  # noqa: E501
            watson_contexts (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.automated_reply = automated_reply
        self.automated_reply_additional_info = automated_reply_additional_info
        self.sms_sid = sms_sid
        self.sms_message_sid = sms_message_sid
        self.sms_status = sms_status
        self.account_sid = account_sid
        self.message_sid = message_sid
        self.body = body
        self.num_segments = num_segments
        self.to = to
        self.to_city = to_city
        self.to_state = to_state
        self.to_zip = to_zip
        self.to_country = to_country
        self._from = _from
        self.from_city = from_city
        self.from_state = from_state
        self.from_zip = from_zip
        self.from_country = from_country
        self.num_media = num_media
        self.api_version = api_version
        self.merchant_id = merchant_id
        self.created_at = created_at
        self.updated_at = updated_at
        self.is_active = is_active
        self.body_lowercase = body_lowercase
        self.from_localized = from_localized
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, automated_reply, automated_reply_additional_info, sms_sid, sms_message_sid, sms_status, account_sid, message_sid, body, num_segments, to, to_city, to_state, to_zip, to_country, _from, from_city, from_state, from_zip, from_country, num_media, api_version, merchant_id, created_at, updated_at, is_active, body_lowercase, from_localized, *args, **kwargs):  # noqa: E501
        """InboundSMS - a model defined in OpenAPI

        Args:
            id (bool, date, datetime, dict, float, int, list, str, none_type):
            automated_reply (str):
            automated_reply_additional_info (str):
            sms_sid (str):
            sms_message_sid (str):
            sms_status (str):
            account_sid (str):
            message_sid (str):
            body (str):
            num_segments (int):
            to (str):
            to_city (str):
            to_state (str):
            to_zip (str):
            to_country (str):
            _from (str):
            from_city (str):
            from_state (str):
            from_zip (str):
            from_country (str):
            num_media (int):
            api_version (str):
            merchant_id (SSNanoID):
            created_at (datetime):
            updated_at (datetime):
            is_active (bool):
            body_lowercase (str):
            from_localized (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            messaging_service_sid (str): [optional]  # noqa: E501
            media_urls ([str]): [optional]  # noqa: E501
            watson_intent (str): [optional]  # noqa: E501
            watson_intents (str): [optional]  # noqa: E501
            watson_context (str): [optional]  # noqa: E501
            watson_contexts (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.automated_reply = automated_reply
        self.automated_reply_additional_info = automated_reply_additional_info
        self.sms_sid = sms_sid
        self.sms_message_sid = sms_message_sid
        self.sms_status = sms_status
        self.account_sid = account_sid
        self.message_sid = message_sid
        self.body = body
        self.num_segments = num_segments
        self.to = to
        self.to_city = to_city
        self.to_state = to_state
        self.to_zip = to_zip
        self.to_country = to_country
        self._from = _from
        self.from_city = from_city
        self.from_state = from_state
        self.from_zip = from_zip
        self.from_country = from_country
        self.num_media = num_media
        self.api_version = api_version
        self.merchant_id = merchant_id
        self.created_at = created_at
        self.updated_at = updated_at
        self.is_active = is_active
        self.body_lowercase = body_lowercase
        self.from_localized = from_localized
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
