"""
    wallet-api

    API  # noqa: E501

    The version of the OpenAPI document: 2.1.524
    Contact: development@wallet.inc
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from wallet.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from wallet.exceptions import ApiAttributeError


def lazy_import():
    from wallet.model.ss_nano_id import SSNanoID
    from wallet.model.ss_opt_in_source import SSOptInSource
    globals()['SSNanoID'] = SSNanoID
    globals()['SSOptInSource'] = SSOptInSource


class OptInListSubscriber(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('referring_url',): {
            'min_length': 0,
        },
        ('id',): {
            'max_length': 12,
            'min_length': 10,
        },
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'opt_in_list_id': (SSNanoID,),  # noqa: E501
            'opt_in_source_id': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'is_subscribed': (bool,),  # noqa: E501
            'is_pending_age21_verification': (bool,),  # noqa: E501
            'mobile_phone_number': (str,),  # noqa: E501
            'referring_url': (str,),  # noqa: E501
            'id': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'merchant_id': (SSNanoID,),  # noqa: E501
            'created_at': (datetime,),  # noqa: E501
            'updated_at': (datetime,),  # noqa: E501
            'is_active': (bool,),  # noqa: E501
            'opted_status': (bool,),  # noqa: E501
            'source': (SSOptInSource,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'opt_in_list_id': 'optInListID',  # noqa: E501
        'opt_in_source_id': 'optInSourceID',  # noqa: E501
        'is_subscribed': 'isSubscribed',  # noqa: E501
        'is_pending_age21_verification': 'isPendingAge21Verification',  # noqa: E501
        'mobile_phone_number': 'mobilePhoneNumber',  # noqa: E501
        'referring_url': 'referringURL',  # noqa: E501
        'id': 'id',  # noqa: E501
        'merchant_id': 'merchantID',  # noqa: E501
        'created_at': 'createdAt',  # noqa: E501
        'updated_at': 'updatedAt',  # noqa: E501
        'is_active': 'isActive',  # noqa: E501
        'opted_status': 'optedStatus',  # noqa: E501
        'source': 'Source',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, opt_in_list_id, opt_in_source_id, is_subscribed, is_pending_age21_verification, mobile_phone_number, referring_url, id, merchant_id, created_at, updated_at, is_active, *args, **kwargs):  # noqa: E501
        """OptInListSubscriber - a model defined in OpenAPI

        Args:
            opt_in_list_id (SSNanoID):
            opt_in_source_id (bool, date, datetime, dict, float, int, list, str, none_type):
            is_subscribed (bool):
            is_pending_age21_verification (bool):
            mobile_phone_number (str):
            referring_url (str):
            id (bool, date, datetime, dict, float, int, list, str, none_type):
            merchant_id (SSNanoID):
            created_at (datetime):
            updated_at (datetime):
            is_active (bool):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            opted_status (bool): [optional]  # noqa: E501
            source (SSOptInSource): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.opt_in_list_id = opt_in_list_id
        self.opt_in_source_id = opt_in_source_id
        self.is_subscribed = is_subscribed
        self.is_pending_age21_verification = is_pending_age21_verification
        self.mobile_phone_number = mobile_phone_number
        self.referring_url = referring_url
        self.id = id
        self.merchant_id = merchant_id
        self.created_at = created_at
        self.updated_at = updated_at
        self.is_active = is_active
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, opt_in_list_id, opt_in_source_id, is_subscribed, is_pending_age21_verification, mobile_phone_number, referring_url, id, merchant_id, created_at, updated_at, is_active, *args, **kwargs):  # noqa: E501
        """OptInListSubscriber - a model defined in OpenAPI

        Args:
            opt_in_list_id (SSNanoID):
            opt_in_source_id (bool, date, datetime, dict, float, int, list, str, none_type):
            is_subscribed (bool):
            is_pending_age21_verification (bool):
            mobile_phone_number (str):
            referring_url (str):
            id (bool, date, datetime, dict, float, int, list, str, none_type):
            merchant_id (SSNanoID):
            created_at (datetime):
            updated_at (datetime):
            is_active (bool):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            opted_status (bool): [optional]  # noqa: E501
            source (SSOptInSource): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.opt_in_list_id = opt_in_list_id
        self.opt_in_source_id = opt_in_source_id
        self.is_subscribed = is_subscribed
        self.is_pending_age21_verification = is_pending_age21_verification
        self.mobile_phone_number = mobile_phone_number
        self.referring_url = referring_url
        self.id = id
        self.merchant_id = merchant_id
        self.created_at = created_at
        self.updated_at = updated_at
        self.is_active = is_active
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
